package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomTypeInUseException;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;
import gz.cyberbrain.cyberhotel.model.roomtype.to.RoomTypeTo;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

public class RoomTypeController {

	private static ConfigurationFacadeDelegate delegate = SpringFacadeFactory.getConfigurationFacadeDelegate();
	private static HashMap<String, String> attributes = new HashMap<String, String>();
	
	private RoomTypeController() {}
	
	public static Vector roomTypeList() throws InternalErrorException {				
		Vector<TextItem> items = new Vector<TextItem> ();
		Collection roomTypes = delegate.showRoomTypes();
		Iterator iter = roomTypes.iterator();

		RoomTypeTo roomType;

		for (int i=0; iter.hasNext(); i++) {

			roomType = (RoomTypeTo) iter.next();
			items.add(new TextItem(roomType.getRoomTypeCode(), roomType.getDescription()));

		}

		return items;
	}

	public static Serializable createRoomType(String roomTypeCode, String description) throws InternalErrorException {
		return delegate.createRoomType(new RoomTypeTo(roomTypeCode, description)).getRoomTypeCode();
	}

	public static void updateRoomType(String roomTypeCode, String description) throws InternalErrorException {		
		delegate.updateRoomType(new RoomTypeTo(roomTypeCode, description));
	}
	
	public static void deleteRoomType(String roomTypeCode) throws InstanceNotFoundException, RoomTypeInUseException, InternalErrorException{
		RoomTypeTo roomType = delegate.findRoomType(roomTypeCode);
		delegate.deleteRoomType(roomType);
	}
	
	public static HashMap findRoomType(String roomTypeCode) throws InstanceNotFoundException, InternalErrorException {
		RoomTypeTo roomType = delegate.findRoomType(roomTypeCode);
		
		attributes.put("code", roomTypeCode);
		attributes.put("description", roomType.getDescription());
		
		return attributes;
				
	}
		
}
