package gz.cyberbrain.cyberhotel.model.bank.dao;

import gz.cyberbrain.cyberhotel.model.bank.to.BankTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface BankDao {

	public BankTo create(BankTo bankTo) throws InternalErrorException;

	public BankTo find(Long bankId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (BankTo bankTo) 
		throws InternalErrorException;
	
	public void remove(BankTo bankTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public boolean existClients (Long bankId) throws InternalErrorException;
	
}
