package gz.cyberbrain.cyberhotel.model.card.dao;

import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class CardSpringDao extends AbstractSpringDao implements CardDao {

	public CardSpringDao() {
		super(CardTo.class);
	}	

	public CardTo create(CardTo cardTo) throws InternalErrorException {		

		return (CardTo) super.save(cardTo);

	}

	public CardTo find(Long cardId) throws InstanceNotFoundException, InternalErrorException {

		CardTo cardTo = (CardTo) super.find(cardId);
		return cardTo;

	}

	public void update(CardTo cardTo) throws InternalErrorException {		

		super.update(cardTo);

	}

	public void remove(CardTo cardTo) throws InternalErrorException {

			super.delete(cardTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allCards";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existClients(Long cardId) throws InternalErrorException {
		String queryName = "cardClients";
		return (!super.findByAttribute(queryName, cardId).isEmpty());
	}
	
}
