package gz.cyberbrain.cyberhotel.model.day.dao;

import gz.cyberbrain.cyberhotel.model.day.to.DayTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public class DaySpringDao extends AbstractSpringDao implements DayDao {

	public DaySpringDao() {
		super(DayTo.class);
	}	

	public DayTo create(DayTo dayTo) throws InternalErrorException {		

		return (DayTo) super.save(dayTo);

	}

	public DayTo find(Calendar dayDate) throws InstanceNotFoundException, InternalErrorException {

		DayTo dayTo = (DayTo) super.find(dayDate);
		return dayTo;

	}

	public void update(DayTo dayTo) throws InternalErrorException {		

		super.saveOrUpdate(dayTo);

	}

	public void remove(DayTo dayTo) throws InternalErrorException {

		super.delete(dayTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allDays";
		return super.findByQuery(queryName);

	}

	public Collection findBySeason(Long seasonId) throws InternalErrorException {
		String queryName = "seasonDays";
		return super.findByAttribute(queryName, seasonId);
	}

}
