package gz.cyberbrain.cyberhotel.model.owe.dao;

import gz.cyberbrain.cyberhotel.model.owe.to.OweTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public interface OweDao {

	public OweTo create(OweTo oweTo) throws InternalErrorException;

	public OweTo find(Long oweNumber) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (OweTo oweTo) 
		throws InternalErrorException;
	
	public void remove(OweTo oweTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findByRoom(String roomCode) throws InternalErrorException;
	
	public Collection findByParticular(Long particularId) throws InternalErrorException;
	
	public Collection findByRoomAndParticular (String roomCode, Long particularId) 
	throws InternalErrorException;
	
	public Collection findByDate(Calendar date) throws InternalErrorException;
	
	public Long findOweReservation(Calendar date, String roomCode) throws InstanceNotFoundException, InternalErrorException;
	
	//public Long nextOwe(Long oweNumber) throws InternalErrorException;
	
}
