package gz.cyberbrain.cyberhotel.model.room.dao;

import java.util.Calendar;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;

import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;

public class RoomSpringDao extends AbstractSpringDao implements RoomDao {

	public RoomSpringDao() {
		super(RoomTo.class);
	}	

	public RoomTo create(RoomTo roomTo) throws InternalErrorException {		

		return (RoomTo) super.save(roomTo);

	}

	public RoomTo find(String roomCode) throws InstanceNotFoundException, InternalErrorException {

		RoomTo roomTo = (RoomTo) super.find(roomCode);
		return roomTo;

	}

	public void update(RoomTo roomTo) throws InternalErrorException {		

		super.update(roomTo);

	}

	public void remove(RoomTo roomTo) throws InternalErrorException {

			super.delete(roomTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allRooms";
		return super.findByQuery(queryName);
		
	}
	
	public Collection findByType (String type) throws InternalErrorException{
		
		String queryName = "roomByType"; 
		
		return super.findByAttribute(queryName, type);
		
	}
	
	public Collection findByOccupancyStatus (String occupancyStatus) throws InternalErrorException {
		
		String queryName = "roomByOccupancyStatus";
		
		return super.findByAttribute(queryName, occupancyStatus);
		
	}
	
    public Collection findByCleaningStatus (String cleaningStatus) throws InternalErrorException {
		
		String queryName = "roomByCleaningStatus";
		
		return super.findByAttribute(queryName, cleaningStatus);
		
	}	
	
	public Collection findByTypeAndOccupancy (String []attributes) throws InternalErrorException {
		
		String queryName = "roomByTypeAndOccupancy";
		
		return super.findByAttributes(queryName, attributes);
		
	}
	
	public boolean existBoarders(String roomCode) throws InternalErrorException {
		
		String queryName = "roomBoarders";
		
		return (!super.findByAttribute(queryName, roomCode).isEmpty());
	}
	
	public Collection freeBetweenDates(Calendar []dates) 
		throws InternalErrorException {
		
		String queryName = "freeBetweenDates";
		return super.findByAttributes(queryName, dates);
	}
	
	public Collection findAllIds() throws InternalErrorException {

		String queryName = "allRoomIds";
		return super.findByQuery(queryName);
	}
	
	public Long findCurrentCheckIn(String roomCode) throws InternalErrorException {
		
		String queryName = "roomCheckIn";
		Collection checkIn = new HashSet <Long>();
		checkIn = super.findByAttribute(queryName, roomCode);
		Exception e = new Exception("Multiple room check-ins!!!");
		if (checkIn.size() > 1) throw new InternalErrorException(e);
		Iterator iter = checkIn.iterator();
		Integer reservationId = (Integer) iter.next();
		return reservationId.longValue();
		
	}
	
}
