package gz.cyberbrain.cyberhotel.model.user.dao;

import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.user.to.UserTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public interface UserDao {

	public UserTo create(UserTo userTo) throws InternalErrorException;
	
	public UserTo find(String login) 
		throws InstanceNotFoundException, InternalErrorException;

	public void update (UserTo userTo) 
		throws InternalErrorException;

	public void remove(UserTo userTo) 
		throws InternalErrorException;

	public Collection findAll() throws InternalErrorException;
	
	public boolean hasAssociatedItems(String login) throws InternalErrorException;
	
}
