package gz.cyberbrain.cyberhotel.model.user.dao;

import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.user.to.UserTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class UserSpringDao extends AbstractSpringDao implements UserDao{

	public UserSpringDao() {
		super(UserTo.class);
	}	

	public UserTo create(UserTo userTo) throws InternalErrorException {		

		return (UserTo) super.save(userTo);

	}

	public UserTo find(String login) throws InstanceNotFoundException, InternalErrorException {

		UserTo userTo = (UserTo) super.find(login);
		return userTo;

	}

	public void update(UserTo userTo) throws InternalErrorException {		

		super.update(userTo);

	}

	public void remove(UserTo userTo) throws InternalErrorException {

		super.delete(userTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allUsers";
		return super.findByQuery(queryName);

	}
	
	public boolean hasAssociatedItems(String login) throws InternalErrorException {
		
		String queryNameA = "userCashes";
		String queryNameB = "userPayments";
		
		return (!super.findByAttribute(queryNameA, login).isEmpty() 
				|| !super.findByAttribute(queryNameB, login).isEmpty());
		
	}

}
