package gz.cyberbrain.cyberhotel.view.swing.edit;

import gz.cyberbrain.cyberhotel.controller.AddressController;
import gz.cyberbrain.cyberhotel.controller.SaveAdapter;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;
import gz.cyberbrain.cyberhotel.view.swing.FillableWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.DateFormat;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.FloatDocument;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.IntegerDocument;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JPanel;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.io.Serializable;
import java.math.BigDecimal;
import java.text.ParseException;
import java.util.Calendar;
import java.util.HashMap;

import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JRadioButton;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.UIManager;
import javax.swing.border.LineBorder;
import javax.swing.text.Document;
import java.awt.Dimension;

public class EmployeeWindow extends FillableWindow {

	private static final long serialVersionUID = 1L;
	private static EmployeeWindow employeeWindow = null;
	private JPanel jContentPane = null;  //  @jve:decl-index=0:visual-constraint="10,559"
	private InfoPanel infoPanel = null;
	private SaveAdapter saveAdapter = null;  //  @jve:decl-index=0:
	private JInternalFrame owner = null;
	private Serializable id = null;
	private JLabel nameLabel = null;
	private JTextField nameTextField = null;
	private JLabel firstSurnameLabel = null;
	private JTextField firstSurnameTextField = null;
	private JLabel secondSurnameLabel = null;
	private JTextField secondSurnameTextField = null;
	private JLabel nifLabel = null;
	private JTextField nifTextField = null;
	private JLabel bornDateLabel = null;
	private JFormattedTextField bornDateTextField = null;
	private ButtonGroup buttonGroup = null;
	private JRadioButton maleRadioButton = null;
	private JRadioButton femaleRadioButton = null;
	private JLabel maritalStatusLabel = null;
	private JTextField maritalStatusTextField = null;
	private JLabel countryLabel = null;
	private JComboBox countryComboBox = null;
	private JLabel provinceLabel = null;
	private JLabel localityLabel = null;
	private JComboBox provinceComboBox = null;
	private JComboBox localityComboBox = null;
	private JLabel streetLabel = null;
	private JTextField streetTextField = null;
	private JLabel dwellingPlaceLabel = null;
	private JTextField dwellingPlaceTextField = null;
	private JLabel phone1Label = null;
	private JTextField phone1TextField = null;
	private JLabel phone2Label = null;
	private JTextField phone2TextField = null;
	private JLabel jobLabel = null;
	private JTextField jobTextField = null;
	private JLabel hireDateLabel = null;
	private JFormattedTextField hireDateTextField = null;
	private JLabel salaryLabel = null;
	private JTextField salaryTextField = null;
	private JLabel observationsLabel = null;
	private JScrollPane observationsScrollPane = null;
	private JTextArea observationsTextArea = null;
	private JButton saveButton = null;
	private JButton cancelButton = null;

	/**
	 * This is the xxx default constructor
	 */
	private EmployeeWindow() {
		super("", false, true, false, true);
		initialize();
	}

	public static EmployeeWindow getInstance() {
		if (employeeWindow == null) employeeWindow = new EmployeeWindow();
		return employeeWindow;
	}

	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(0,0,this.getWidth(),50);
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);

	}

	public void setAdapter(SaveAdapter saveAdapter) {
		this.saveAdapter = saveAdapter;
	}

	public SaveAdapter getAdapter() {
		return saveAdapter;
	}

	public void setId(Serializable id) {
		this.id = id;
	}

	public Serializable getId() {
		return id;
	}

	public JInternalFrame getOwner() {
		return owner;
	}

	public void setOwner(JInternalFrame owner) {
		this.owner = owner;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(655, 539);
		this.setResizable(false);
		this.setContentPane(getJContentPane());
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
		{
			public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt)
			{
				(EmployeeWindow.getInstance()).clean();
				(EmployeeWindow.getInstance()).dispose();

			}
		});	

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			buttonGroup = new ButtonGroup();
			buttonGroup.add(getMaleRadioButton());
			buttonGroup.add(getFemaleRadioButton());
			observationsLabel = new JLabel();
			observationsLabel.setBounds(new Rectangle(11, 391, 83, 16));
			observationsLabel.setText(Locale.get("EmployeeWindow.observationsLabel"));
			salaryLabel = new JLabel();
			salaryLabel.setBounds(new Rectangle(11, 365, 83, 16));
			salaryLabel.setText(Locale.get("EmployeeWindow.salaryLabel"));
			hireDateLabel = new JLabel();
			hireDateLabel.setBounds(new Rectangle(333, 337, 74, 16));
			hireDateLabel.setText(Locale.get("EmployeeWindow.hireDateLabel"));
			jobLabel = new JLabel();
			jobLabel.setBounds(new Rectangle(11, 338, 83, 16));
			jobLabel.setText(Locale.get("EmployeeWindow.jobLabel"));
			phone2Label = new JLabel();
			phone2Label.setBounds(new Rectangle(191, 287, 38, 16));
			phone2Label.setText(Locale.get("EmployeeWindow.phone2Label"));
			phone1Label = new JLabel();
			phone1Label.setBounds(new Rectangle(11, 287, 83, 16));
			phone1Label.setText(Locale.get("EmployeeWindow.phone1Label"));
			dwellingPlaceLabel = new JLabel();
			dwellingPlaceLabel.setBounds(new Rectangle(333, 259, 74, 16));
			dwellingPlaceLabel.setText(Locale.get("EmployeeWindow.dwellingPlaceLabel"));
			streetLabel = new JLabel();
			streetLabel.setBounds(new Rectangle(11, 259, 83, 16));
			streetLabel.setText(Locale.get("EmployeeWindow.streetLabel"));
			localityLabel = new JLabel();
			localityLabel.setBounds(new Rectangle(11, 221, 83, 16));
			localityLabel.setText(Locale.get("EmployeeWindow.localityLabel"));
			provinceLabel = new JLabel();
			provinceLabel.setBounds(new Rectangle(11, 192, 83, 16));
			provinceLabel.setText(Locale.get("EmployeeWindow.provinceLabel"));
			countryLabel = new JLabel();
			countryLabel.setBounds(new Rectangle(11, 162, 83, 16));
			countryLabel.setText(Locale.get("EmployeeWindow.countryLabel"));
			maritalStatusLabel = new JLabel();
			maritalStatusLabel.setBounds(new Rectangle(333, 95, 74, 16));
			maritalStatusLabel.setText(Locale.get("EmployeeWindow.maritalStatusLabel"));
			bornDateLabel = new JLabel();
			bornDateLabel.setBounds(new Rectangle(333, 66, 90, 16));
			bornDateLabel.setText(Locale.get("EmployeeWindow.bornDateLabel"));
			nifLabel = new JLabel();
			nifLabel.setBounds(new Rectangle(505, 66, 33, 16));
			nifLabel.setText(Locale.get("EmployeeWindow.nifLabel"));
			secondSurnameLabel = new JLabel();
			secondSurnameLabel.setBounds(new Rectangle(11, 124, 90, 16));
			secondSurnameLabel.setText(Locale.get("EmployeeWindow.secondSurnameLabel"));
			firstSurnameLabel = new JLabel();
			firstSurnameLabel.setBounds(new Rectangle(11, 95, 90, 16));
			firstSurnameLabel.setText(Locale.get("EmployeeWindow.firstSurnameLabel"));
			nameLabel = new JLabel();
			nameLabel.setBounds(new Rectangle(11, 66, 83, 16));
			nameLabel.setText(Locale.get("EmployeeWindow.nameLabel"));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setSize(new Dimension(645, 503));
			jContentPane.add(getInfoPanel(),null);
			jContentPane.add(nameLabel, null);
			jContentPane.add(getNameTextField(), null);
			jContentPane.add(firstSurnameLabel, null);
			jContentPane.add(getFirstSurnameTextField(), null);
			jContentPane.add(secondSurnameLabel, null);
			jContentPane.add(getSecondSurnameTextField(), null);
			jContentPane.add(nifLabel, null);
			jContentPane.add(getNifTextField(), null);
			jContentPane.add(bornDateLabel, null);
			jContentPane.add(getBornDateTextField(), null);
			jContentPane.add(getMaleRadioButton(), null);
			jContentPane.add(getFemaleRadioButton(), null);
			jContentPane.add(maritalStatusLabel, null);
			jContentPane.add(getMaritalStatusTextField(), null);
			jContentPane.add(countryLabel, null);
			jContentPane.add(getCountryComboBox(), null);
			jContentPane.add(provinceLabel, null);
			jContentPane.add(localityLabel, null);
			jContentPane.add(getProvinceComboBox(), null);
			jContentPane.add(getLocalityComboBox(), null);
			jContentPane.add(streetLabel, null);
			jContentPane.add(getStreetTextField(), null);
			jContentPane.add(dwellingPlaceLabel, null);
			jContentPane.add(getDwellingPlaceTextField(), null);
			jContentPane.add(phone1Label, null);
			jContentPane.add(getPhone1TextField(), null);
			jContentPane.add(phone2Label, null);
			jContentPane.add(getPhone2TextField(), null);
			jContentPane.add(jobLabel, null);
			jContentPane.add(getJobTextField(), null);
			jContentPane.add(hireDateLabel, null);
			jContentPane.add(getHireDateTextField(), null);
			jContentPane.add(salaryLabel, null);
			jContentPane.add(getSalaryTextField(), null);
			jContentPane.add(observationsLabel, null);
			jContentPane.add(getObservationsScrollPane(), null);
			jContentPane.add(getSaveButton(), null);
			jContentPane.add(getCancelButton(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes nameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNameTextField() {
		if (nameTextField == null) {
			nameTextField = new JTextField();
			nameTextField.setBounds(new Rectangle(105, 66, 142, 18));
		}
		return nameTextField;
	}

	/**
	 * This method initializes firstSurnameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getFirstSurnameTextField() {
		if (firstSurnameTextField == null) {
			firstSurnameTextField = new JTextField();
			firstSurnameTextField.setBounds(new Rectangle(105, 95, 217, 18));
		}
		return firstSurnameTextField;
	}

	/**
	 * This method initializes secondSurnameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSecondSurnameTextField() {
		if (secondSurnameTextField == null) {
			secondSurnameTextField = new JTextField();
			secondSurnameTextField.setBounds(new Rectangle(105, 124, 217, 18));
		}
		return secondSurnameTextField;
	}

	/**
	 * This method initializes nifTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNifTextField() {
		if (nifTextField == null) {
			nifTextField = new JTextField();
			nifTextField.setBounds(new Rectangle(543, 66, 92, 18));
		}
		return nifTextField;
	}

	/**
	 * This method initializes bornDateTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getBornDateTextField() {

		try {

			if (bornDateTextField == null) {
				bornDateTextField = new JFormattedTextField(new DateFormat());			
				bornDateTextField.setBounds(new Rectangle(427, 66, 74, 18));
			}

		} catch (ParseException e) {
			e.printStackTrace();
		}

		return bornDateTextField;
	}

	/**
	 * This method initializes maleRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getMaleRadioButton() {
		if (maleRadioButton == null) {
			maleRadioButton = new JRadioButton();
			maleRadioButton.setBounds(new Rectangle(337, 124, 68, 21));
			maleRadioButton.setText(Locale.get("EmployeeWindow.maleRadioButton"));
		}
		return maleRadioButton;
	}

	/**
	 * This method initializes femaleRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getFemaleRadioButton() {
		if (femaleRadioButton == null) {
			femaleRadioButton = new JRadioButton();
			femaleRadioButton.setBounds(new Rectangle(424, 124, 68, 21));
			femaleRadioButton.setText(Locale.get("EmployeeWindow.femaleRadioButton"));
		}
		return femaleRadioButton;
	}

	/**
	 * This method initializes maritalStatusTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getMaritalStatusTextField() {
		if (maritalStatusTextField == null) {
			maritalStatusTextField = new JTextField();
			maritalStatusTextField.setBounds(new Rectangle(426, 95, 209, 18));
		}
		return maritalStatusTextField;
	}

	/**
	 * This method initializes countryComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCountryComboBox() {
		if (countryComboBox == null) {
			countryComboBox = new JComboBox(AddressController.countriesList().toArray());
			countryComboBox.setBounds(new Rectangle(105, 162, 217, 18));
			countryComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {


					ComboBoxModel model = new DefaultComboBoxModel(AddressController.countryProvincesList((String)getCountryComboBox().getSelectedItem()).toArray());
					getProvinceComboBox().setModel(model);
					if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(0); 


				}
			});
		}
		return countryComboBox;
	}

	/**
	 * This method initializes provinceComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getProvinceComboBox() {
		if (provinceComboBox == null) {
			provinceComboBox = new JComboBox(AddressController.countryProvincesList((String) getCountryComboBox().getSelectedItem()).toArray());
			provinceComboBox.setBounds(new Rectangle(105, 192, 217, 18));
			provinceComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					ComboBoxModel model = new DefaultComboBoxModel(AddressController.provinceLocalitiesList((String)getCountryComboBox().getSelectedItem(), (String)getProvinceComboBox().getSelectedItem()).toArray());
					getLocalityComboBox().setModel(model);						
					if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(0);

				}
			});
		}
		return provinceComboBox;
	}

	/**
	 * This method initializes localityComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getLocalityComboBox() {
		if (localityComboBox == null) {
			localityComboBox = new JComboBox(AddressController.provinceLocalitiesList((String)getCountryComboBox().getSelectedItem(), (String)getProvinceComboBox().getSelectedItem()).toArray());
			localityComboBox.setBounds(new Rectangle(105, 221, 217, 18));
		}
		return localityComboBox;
	}

	/**
	 * This method initializes streetTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getStreetTextField() {
		if (streetTextField == null) {
			streetTextField = new JTextField();
			streetTextField.setBounds(new Rectangle(106, 259, 217, 18));
		}
		return streetTextField;
	}

	/**
	 * This method initializes dwellingPlaceTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDwellingPlaceTextField() {
		if (dwellingPlaceTextField == null) {
			dwellingPlaceTextField = new JTextField();
			dwellingPlaceTextField.setBounds(new Rectangle(426, 259, 208, 18));
		}
		return dwellingPlaceTextField;
	}

	/**
	 * This method initializes phone1TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhone1TextField() {
		if (phone1TextField == null) {
			Document integerDocument = new IntegerDocument(15);
			phone1TextField = new JTextField(integerDocument,"",15);			
			phone1TextField.setHorizontalAlignment(JTextField.TRAILING);	
			phone1TextField.setBounds(new Rectangle(107, 286, 77, 18));
		}
		return phone1TextField;
	}

	/**
	 * This method initializes phone2TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhone2TextField() {
		if (phone2TextField == null) {
			Document integerDocument = new IntegerDocument(15);
			phone2TextField = new JTextField(integerDocument,"",15);
			phone2TextField.setHorizontalAlignment(JTextField.TRAILING);
			phone2TextField.setBounds(new Rectangle(236, 286, 77, 18));
		}
		return phone2TextField;
	}

	/**
	 * This method initializes jobTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJobTextField() {
		if (jobTextField == null) {
			jobTextField = new JTextField();
			jobTextField.setBounds(new Rectangle(106, 338, 217, 18));
		}
		return jobTextField;
	}

	/**
	 * This method initializes hireDateTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getHireDateTextField() {

		try {

			if (hireDateTextField == null) {

				hireDateTextField = new JFormattedTextField(new DateFormat());				
				hireDateTextField.setBounds(new Rectangle(426, 337, 74, 18));

			}

		} catch (ParseException e) {
			e.printStackTrace();
		}

		return hireDateTextField;
	}

	/**
	 * This method initializes salaryTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSalaryTextField() {
		if (salaryTextField == null) {
			Document floatDocument = new FloatDocument();
			salaryTextField = new JTextField(floatDocument,"",15);
			salaryTextField.setHorizontalAlignment(JTextField.TRAILING);
			salaryTextField.setBounds(new Rectangle(106, 365, 92, 18));
		}
		return salaryTextField;
	}

	/**
	 * This method initializes observationsScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getObservationsScrollPane() {
		if (observationsScrollPane == null) {
			observationsScrollPane = new JScrollPane();
			observationsScrollPane.setBounds(new Rectangle(10, 414, 623, 60));
			observationsScrollPane.setViewportView(getObservationsTextArea());
		}
		return observationsScrollPane;
	}

	/**
	 * This method initializes observationsTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getObservationsTextArea() {
		if (observationsTextArea == null) {
			observationsTextArea = new JTextArea();
		}
		return observationsTextArea;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setBounds(new Rectangle(465, 481, 76, 16));
			saveButton.setText(Locale.get("EmployeeWindow.saveButton"));
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					HashMap<String, Object> attrs = new HashMap<String, Object>();
					attrs.put("id", (Long) getId());

					attrs.put("address", 
							AddressController.findAddressId(
									(String) getCountryComboBox().getSelectedItem(), 
									(String) getProvinceComboBox().getSelectedItem(),
									(String) getLocalityComboBox().getSelectedItem()
							)
					);

					attrs.put("street", getStreetTextField().getText());
					attrs.put("dwellingPlace", getDwellingPlaceTextField().getText()); 
					attrs.put("phone1", getPhone1TextField().getText());
					attrs.put("phone2", getPhone2TextField().getText());

					attrs.put("nif", getNifTextField().getText());
					attrs.put("notes", getObservationsTextArea().getText()); 
					attrs.put("name", getNameTextField().getText());
					attrs.put("firstSurname", getFirstSurnameTextField().getText());
					attrs.put("secondSurname", getSecondSurnameTextField().getText());																				
					attrs.put("bornDate", DateOperations.textToCalendar(getBornDateTextField().getText()));										

					String sex;
					if (getMaleRadioButton().isSelected()) sex = "H"; else sex = "M";
					attrs.put("sex", sex);
					
					attrs.put("maritalStatus", getMaritalStatusTextField().getText());

					attrs.put("job", getJobTextField().getText());


					attrs.put("hireDate", DateOperations.textToCalendar(getHireDateTextField().getText()));

					try {

						attrs.put("salary", new BigDecimal(getSalaryTextField().getText()));

					} catch (NumberFormatException e1) {
						attrs.put("salary", new BigDecimal("0"));
					}

					attrs.put("observations", getObservationsTextArea().getText());

					getAdapter().save(attrs);

					if (!inputErrors()) {

						Object[] options = {Locale.get("JOptionPane.Ok")};
						int n = JOptionPane.showOptionDialog(RoomTypeWindow.getInstance(),
								Locale.get("JOptionPane.EmployeeWindow.saveButton.message"),
								Locale.get("JOptionPane.EmployeeWindow.saveButton.title"),
								JOptionPane.OK_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);

						if (n == JOptionPane.OK_OPTION) {
							ListWindow listWindow = (ListWindow) getOwner();						
							listWindow.loadList();
							clean();
							dispose();	                    	
						}											

						ListWindow listWindow = (ListWindow) getOwner();
						listWindow.loadList();

					}

				}

			});
		}
		return saveButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setBounds(new Rectangle(557, 481, 76, 16));
			cancelButton.setText(Locale.get("EmployeeWindow.cancelButton"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(EmployeeWindow.getInstance()).clean();
					(EmployeeWindow.getInstance()).dispose();

				}
			});
		}
		return cancelButton;
	}

	@Override
	public void clean() {
		getInfoPanel().setInfoText(getInfoPanel().getInfoText());

		getNameTextField().setText("");
		getBornDateTextField().setText(DateOperations.calendarToText(Calendar.getInstance()));
		getNifTextField().setText("");
		getFirstSurnameTextField().setText("");
		getSecondSurnameTextField().setText("");
		getMaritalStatusTextField().setText("");
		if (getCountryComboBox().getItemCount() != 0) getCountryComboBox().setSelectedIndex(0);
		if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(0);
		if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(0);
		getStreetTextField().setText("");
		getDwellingPlaceTextField().setText("");

		getHireDateTextField().setText(DateOperations.calendarToText(Calendar.getInstance()));
		getJobTextField().setText("");
		getPhone1TextField().setText("");
		getPhone2TextField().setText("");

		getSalaryTextField().setText("");
		getObservationsTextArea().setText("");

		getMaleRadioButton().doClick();

		getNameTextField().setBorder(UIManager.getBorder("TextField.border"));
		getNifTextField().setBorder(UIManager.getBorder("TextField.border"));
		getFirstSurnameTextField().setBorder(UIManager.getBorder("TextField.border"));
		getSecondSurnameTextField().setBorder(UIManager.getBorder("TextField.border"));

		getCountryComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getProvinceComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getLocalityComboBox().setBorder(UIManager.getBorder("ComboBox.border"));

		getHireDateTextField().setBorder(UIManager.getBorder("TextField.border"));
		getSalaryTextField().setBorder(UIManager.getBorder("TextField.border"));

	}

	@Override
	public void fill(HashMap fields) {

		getNameTextField().setText((String) fields.get("name"));
		getBornDateTextField().setText(DateOperations.calendarToText((Calendar) fields.get("bornDate")));
		getNifTextField().setText((String) fields.get("nif"));
		getFirstSurnameTextField().setText((String) fields.get("firstSurname"));
		getSecondSurnameTextField().setText((String) fields.get("secondSurname"));	
		getMaritalStatusTextField().setText((String) fields.get("maritalStatus"));
		getCountryComboBox().setSelectedItem(AddressController.addressCountry((Long) fields.get("address")));
		getProvinceComboBox().setSelectedItem(AddressController.addressProvince((Long) fields.get("address")));
		getLocalityComboBox().setSelectedItem(AddressController.addressLocality((Long) fields.get("address")));
		getStreetTextField().setText((String) fields.get("street"));
		getDwellingPlaceTextField().setText((String) fields.get("dwellingPlace"));
		getJobTextField().setText((String) fields.get("job"));
		getPhone1TextField().setText((String) fields.get("phone1"));
		getPhone2TextField().setText((String) fields.get("phone2"));
		getHireDateTextField().setText(DateOperations.calendarToText((Calendar) fields.get("hireDate")));
		getSalaryTextField().setText(fields.get("salary").toString());

		String sex = ((String) fields.get("sex"));
		if (sex.equals("H")) getMaleRadioButton().setSelected(true);
		else getFemaleRadioButton().setSelected(true);

		getObservationsTextArea().setText((String) fields.get("observations"));

	}

	private boolean inputErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("address")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ParticularWindow.errors.address")+ "</html>");				
				getCountryComboBox().setBorder(new LineBorder(Color.red, 2));
				getProvinceComboBox().setBorder(new LineBorder(Color.red, 2));
				getLocalityComboBox().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("name")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("EmployeeWindow.errors.name")+ "</html>");
				getNameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("firstSurname")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("EmployeeWindow.errors.firstSurname")+ "</html>");
				getFirstSurnameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("secondSurname")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("EmployeeWindow.errors.secondSurname")+ "</html>");
				getSecondSurnameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

		}

		return false;

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
